#!/usr/bin/perl
#

BEGIN { push @INC, '/usr/local/bin'; }
use integer;
use Getopt::Long;
use HDLservice;
use HDLsystem;

use HDLsmbconf;

# 排他ロックの取得
$sys = HDLsystem->new( write => 1, exclusive => 1 );
die "cannot open conf file\n" if !defined $sys;

# 引数の取得
GetOptions ( 'getservice!', 'update!',
	     'setversion:s',
	     'setsubversion:s',
	     'setbeta:s'
	     );

if ( $opt_getservice ) {
    # 現在有効なサービスの取得
    $serv = HDLservice->new();
    die "cannot open conf file\n" if !defined $serv;

    @opts = ();
    @services = keys %{$serv->get()};

    # 値の表示
    foreach $k ( @services ) {
	printf "$k=%s\n", $serv->get ( $k );
    }
    undef $serv;
    undef $sys;
    exit 0;
}


if ( defined $opt_setversion
     || defined $opt_setsubversion
     || defined $opt_setbeta ) {

    
    if ( !defined $opt_setbeta ) {
        $sys->set( version    => $opt_setversion   ) if ( defined $opt_setversion );
	$sys->set( subversion => $opt_setsubversion) if ( defined $opt_setsubversion );
	$sys->set( beta => '' );
    } else {
	$sys->set( beta => $opt_setbeta );
    }
    $sys->commit();
    undef $sys;
    exit 0;
}

if ( $opt_update ) {
   # アップデート処理

	$smb = HDLsmbconf->new( write => 1 );
	$smb->set ('global','client_schannel','no' );
	$smb->set ('global','use_sendfile'   ,'yes');
	$smb->set ('global','passdb_backend','tdbsam');
	$smb->commit();
	undef $smb;

    undef $sys;
    exit 0;
}

undef $sys;
exit 0;


